Imports System.Text.RegularExpressions

Module ModApplication

    Sub Main()
        Console.WriteLine("IsMatch-Sample:")
        Show_IsMatch()
        Console.WriteLine()

        Console.WriteLine("Replace-Sample:")
        Show_Replace()
        Console.WriteLine()

        Console.WriteLine("Replace-Callback-Sample:")
        Show_Replace_Callback()
        Console.WriteLine()

        Console.ReadLine()
    End Sub

#Region " IsMatch-Sample "

    Private Sub Show_IsMatch()
        Dim TestString As String = "http://colinschlueter.de"

        If Regex.IsMatch( _
            TestString, _
            "^http://[a-z]+[-a-z]+(\.[a-z]+)?$", _
            RegexOptions.IgnoreCase Or RegexOptions.Singleline _
        ) Then
            Console.WriteLine(TestString & " ist eine gltige URL")
        Else
            Console.WriteLine(TestString & " ist keine gltige URL")
        End If
    End Sub

#End Region

#Region " Replace-Sample "

    Private Sub Show_Replace()
        Dim TestString As String = "Ich  wei   nicht, was  soll das " & vbTab & " bedeuten?"

        Console.WriteLine("Vorher: " & TestString)

        TestString = _
            New Regex( _
                "\s+(\w)", _
                RegexOptions.IgnoreCase Or RegexOptions.Multiline _
            ).Replace(TestString, " ($1)")

        Console.WriteLine("Nachher: " & TestString)
    End Sub

#End Region

#Region " Replace-Callback-Sample "

    Private Sub Show_Replace_Callback()
        Dim TestString As String = "Ich wei nicht, was soll das bedeuten?"

        Console.WriteLine("Vorher: " & TestString)

        TestString = _
            New Regex( _
                "\s+(\w)", _
                RegexOptions.IgnoreCase Or RegexOptions.Multiline _
            ).Replace(TestString, New MatchEvaluator(AddressOf ReplaceCallback))

        Console.WriteLine("Nachher: " & TestString)
    End Sub

    Private Function ReplaceCallback(ByVal Match As Match) As String
        Return Match.Value.ToUpper
    End Function

#End Region

End Module
